/*
 *  GOL - Game of life simulation software
 *  Copyright (C) 1996 Michael Raymond Brown
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Author: Michael Raymond Brown
 *  EMail:  michael@arrakeen.demon.co.uk
 *  WWW:    http://www.arrakeen.demon.co.uk/
 *  Address:  Michael Brown
 *            Kia Ora
 *            Brook Street
 *            Great Bromley
 *            Nr Colchester
 *            Essex
 *            CO7 7HX
 *            England
 */


#include "lif_life.h"
#include <string.h>
#include <stdio.h>
#include <errno.h>

extern const char* lasterrstr;
extern int	   lasterrnum;

int open_lif_life(Life* life, const char* fname, int* widthp, int* heightp, char* rules)
   {char* ptr;
    char line[81];
    int x, ox = life->getWidth() / 2;
    int y, oy = life->getHeight() / 2;

    FILE* fp = fopen(fname, "r");
    if (!fp)
       {lasterrnum=errno;
	lasterrstr=strerror(errno);
	return -1;
       }

    while (fgets(line, 80, fp))
       {if (ptr=strchr(line, '\r')) *ptr='\0';
	if (ptr=strchr(line, '\n')) *ptr='\0';

	if (line[0] == '#')
	   {if (line[1] == 'P')
	       {sscanf(line+3, "%d%d", &x, &y);
		x+=ox; y+=oy;
	       }
	   }
	else if (line[0])
	   {int nx = x;
	    for (ptr=line; *ptr; ptr++)
		{if (*ptr == '*') life->plot(nx, y, 1);
		 nx++;
		}
	    y++;
	   }
       }
    fclose(fp);

    return 0;
   }

int save_lif_life(Life* life, const char* fname)
   {return 0;
   }

